/********************************************************************
 * COPYRIGHT --  
 ********************************************************************
 * Program: SingleAx
 * File: SingleAx.c
 * Author: lin
 * Created: December 29, 2011
 ********************************************************************
 * Implementation of program SingleAx
 ********************************************************************/

#include <bur/plctypes.h>
#include <string.h>

#ifdef _DEFAULT_INCLUDES
	#include <AsDefault.h>
#endif
/* Define axis member */

/* STEP step */
#define STEP_WAIT_INIT_ALLOWED    	0
#define	STEP_NETWORK_INIT	  		1
#define STEP_WAIT_NET_INIT		  	2
#define STEP_PARA_DOWN				10
#define STEP_WAIT_PAR_DOWN			11
#define STEP_SWITCH_OFF       		20
#define STEP_WAIT_SWITCH_OFF        21
#define STEP_GLOBAL_INIT       		30
#define STEP_WAIT_GLOBAL_INIT     	31
#define STEP_SIMULATE_MODE          40
#define STEP_WAIT_SIMULATE_STATUS   41
#define STEP_INIT_CTRL_RDY   		50
#define STEP_WAIT_CTRL_RDY        	51
#define STEP_SWITCH_ON        		60
#define STEP_WAIT_SWITCH_ON         61
#define STEP_HOME_START        		70
#define STEP_WAIT_HOME_OK         	71
#define STEP_COMMAND           		80
#define STEP_POS_MOVEMENT      		90
#define STEP_NEG_MOVEMENT      		100
#define STEP_POS_JOG				110
#define STEP_WAIT_POS_JOG			111
#define STEP_NEG_JOG				120
#define STEP_WAIT_NEG_JOG			121
#define STEP_ABS_MOVEMENT      		130
#define STEP_REL_MOVEMENT      		140
#define STEP_WAIT_IN_POS          	150
#define STEP_STOP_MOVEMENT     		160
#define STEP_ESTOP_MOVEMENT     	170
#define STEP_WAIT_STOP_MOVEMENT   	180
#define	STEP_START_AUTOMAT			190
#define STEP_RESTART_AUTOMAT		200
#define	STEP_STOP_AUTOMAT			210
#define STEP_WAIT_SERVICE_SET		220
#define STEP_SWITCH_OFF_1      		230
#define STEP_SWITCH_OFF_2      		231
#define STEP_WAIT_SWITCH_OFF_2    	232
#define STEP_ERROR_STEP        		240
#define STEP_ERR_SWITCH_OFF        	250
#define STEP_WAIT_ERR_SWITCH_OFF    260
#define	STEP_WMSSAGE_ACKN			270
#define STEP_WAIT_MESSAGE_NUMBER  	280
#define STEP_MESSAGE_TEXT      		290
#define STEP_WAIT_MESSAGE_TEXT    	300
#define STEP_MESSAGE_ACKN      		310

void _INIT SingleAxINIT(void)
{
	/* TODO: Add code here */
	isInitOk = 0;
	
	/* Program interface. set variables here */
	/*-------------------------------------------------------------------*/
	strcpy(&gSinAxCtrl.axisObjName[0], "gG_Ax01");
	strcpy(&gSinAxCtrl.downParaName[0][0], "general");
	strcpy(&gSinAxCtrl.downParaName[1][0], "gs_ax01a");
	/*strcpy(&gSinAxCtrl.downParaName[2][0], "");*/
	/*strcpy(&gSinAxCtrl.downParaName[3][0], "");*/
	/*-------------------------------------------------------------------*/
	
	/* Program interface. set variables here */
	/*-------------------------------------------------------------------*/
	pAxisCtrl = &gSinAxCtrl;
	pAxisStatus = &axisStatus;
	/*-------------------------------------------------------------------*/
		
	/* Get AxisObject according to access-name in NC-Deployment-Table */
	pAxisStatus->status = ncaccess(ncACP10MAN, &pAxisCtrl->axisObjName[0], &pAxisStatus->axisObj);
		
	if ( (pAxisStatus->status != ncOK) && (pAxisStatus->status != 10600) )
	{
		/* The NC object pointer is invalid */
		strcpy(&pAxisCtrl->monitor.errInfo[0], "Error to access-name in NC-Deployment-Table ");
		return;
	}
		
	/* Get the pointer of NC manager */
	pAxisCtrl->monitor.axisObj = pAxisStatus->axisObj;
	pAxisData = (ACP10AXIS_typ*)pAxisStatus->axisObj;
		
	if ( pAxisData->size != sizeof(ACP10AXIS_typ) )
	{
		/* The NC data type is not compatible with NC manager */
		pAxisStatus->status = sizeof(ACP10AXIS_typ);
		strcpy(&pAxisCtrl->monitor.errInfo[0], "NC data type is not compatible with NC manager ");
		return;
	}
	else
	{
		pAxisStatus->status = 0;
	}
						
	if ( ( pAxisData->sw_version.nc_manager & 0xFFF0 ) != ( ACP10MAN_H_VERSION & 0xFFF0 ) )
	{
		/* The version is not compatible with NC manager */
		pAxisStatus->status = ACP10MAN_H_VERSION;
		return;
	}
	else 
	{
		pAxisStatus->status = 0;
	}
		
	pAxisData->message.text.parameter.columns = sizeof(pAxisCtrl->monitor.messageText.line_01);
	pAxisData->message.text.parameter.data_len = sizeof(pAxisCtrl->monitor.messageText);
	pAxisData->message.text.parameter.data_adr = (UDINT)&pAxisCtrl->monitor.messageText;
	/*strcpy( &pAxisData->message.text.parameter.data_modul[0], "acp10etxen" );*/
		
	pAxisStatus->simulation = ncOFF;	/* Switch simulation mode off */
	pAxisStatus->errorHalt = ncON;		/* Abort current movement in case of error */
	pAxisStatus->ctrlOff = ncON;		/* Disable loop controler in case of error */
	pAxisCtrl->monitor.errStep = 0;		/* Reset error step */
	
	pAxisStatus->step = STEP_WAIT_INIT_ALLOWED;
	
	isInitOk = 1;	
}/* void _INIT SingleAxINIT(void) */

void _CYCLIC SingleAxCYCLIC(void)
{
	/* TODO: Add code here */
	if (!isInitOk)
	{
		return;
	}
	
	/* Program interface. set variables here */
	/*-------------------------------------------------------------------*/
	pAxisCtrl = &gSinAxCtrl;
	pAxisStatus = &axisStatus;
	/*-------------------------------------------------------------------*/
		
	/* Copy the point from the axisobj */
	pAxisData = (ACP10AXIS_typ*)pAxisStatus->axisObj;
	/* Check for an axis error */		
	if ( ncTRUE == pAxisData->monitor.status.error )
	{
		pAxisCtrl->monitor.errID = pAxisData->message.record.number;
		/* Set error output */
		pAxisCtrl->monitor.errOutput = 1;
			
		if (0 == pAxisCtrl->monitor.errStep)
		{
			pAxisCtrl->monitor.errStep = pAxisStatus->step;
			pAxisStatus->step = STEP_ERROR_STEP;
			strcpy(&pAxisCtrl->monitor.strEng[0], "The axis is error ");
		}
	}/* if ( ncTRUE == pAxisData->monitor.status.error ) */
	else
	{
		pAxisCtrl->monitor.errID = 0;
		/* Reset error output */
		pAxisCtrl->monitor.errOutput = 0;
	}
	/* Refresh monitor data */
	pAxisCtrl->monitor.actPosi = pAxisData->monitor.s;
	pAxisCtrl->monitor.actVel = pAxisData->monitor.v;
	pAxisCtrl->monitor.moveMode = pAxisData->move.mode;
	pAxisCtrl->monitor.ctrlRdy = pAxisData->controller.status;
	pAxisCtrl->monitor.homeRdy = pAxisData->move.homing.status.ok;
	pAxisCtrl->monitor.inPosi = pAxisData->move.basis.status.in_pos;
	pAxisCtrl->monitor.step = pAxisStatus->step;
	pAxisData->move.basis.override.v = pAxisCtrl->config.basisOvrd_v;
	pAxisData->move.basis.override.a = pAxisCtrl->config.basisOvrd_a;
	/* State sequence for handling the NC Object */
	switch (pAxisStatus->step)
	{
		/* Wait until the network is initialized */
		case STEP_WAIT_INIT_ALLOWED:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait until the network is initialized");
			
			if ( ncTRUE == pAxisData->network.init_allowed )
			{
				/* Network initialization allowed */
				pAxisStatus->step = STEP_NETWORK_INIT;
			}
			break;
		/* Network initialization */
		case STEP_NETWORK_INIT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Network initialization");
				
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncNETWORK, ncINIT);
			if ( ncOK == pAxisStatus->status )
			{
				pAxisStatus->step = STEP_WAIT_NET_INIT;
			}
			break;
		/* Wait network initialization completed */
		case STEP_WAIT_NET_INIT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait network initialization completed");
				
			if ( ncTRUE == pAxisData->network.init )
			{	    		    
				pAxisStatus->step = STEP_SWITCH_OFF;				
			}
			break;		
		/* Parameters from an Acopos-Parameter-Table are trandferred to the drive */
		case STEP_PARA_DOWN:
		strcpy(&pAxisCtrl->monitor.strEng[0], "Parameters from an Acopos-Parameter-Table are trandferred to the drive");
			/* all parameters have been downloaded or no name of cam entered -> end of list */
			if ( ( pAxisStatus->paraTableNr >= ACP10_MAX_PARA_NR )||
				( '\0' == pAxisCtrl->downParaName[pAxisStatus->paraTableNr][0] ) )		 
			{
				pAxisStatus->step = STEP_SWITCH_OFF;
				break;
			}
				
			pAxisStatus->dataDownload.parameter.index = pAxisStatus->paraTableNr+1;		/* index starts with 1 */
			strcpy(&pAxisStatus->dataDownload.parameter.data_modul[0], &pAxisCtrl->downParaName[pAxisStatus->paraTableNr][0]);
			pAxisData->network.service.data_adr = (UDINT)&pAxisStatus->dataDownload;
				
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncACP_PAR+ncSERVICE, ncDOWNLOAD);
			if ( ncOK == pAxisStatus->status )
			{
				pAxisStatus->step = STEP_WAIT_PAR_DOWN;
			}
			break;	
		/* Wait until parameter table was transferred */
		case STEP_WAIT_PAR_DOWN:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait until parameter table was transferred");
			
			if (0 != pAxisStatus->dataDownload.status.data_len)
			{
				/* Data block transfer successfully finished */
				pAxisStatus->paraTableNr++;
				pAxisStatus->step = STEP_PARA_DOWN;
			}
			if (0 != pAxisStatus->dataDownload.status.error)
			{
				/* Error at data block transfer */
				strcpy(&pAxisCtrl->monitor.errInfo[0], "Error in down load para data module");
				pAxisStatus->step = STEP_ERROR_STEP;
			}
			break;
		/* Switch controller off */
		case STEP_SWITCH_OFF:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Switch controller off");
			
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncCONTROLLER, ncSWITCH_OFF);
			if ( ncOK == pAxisStatus->status )
			{
				pAxisStatus->step = STEP_WAIT_SWITCH_OFF;
			}	
			break;	    		    
		/* Wait for controller off */
		case STEP_WAIT_SWITCH_OFF:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for controller off");
			
			if ( ncOFF == pAxisData->controller.status )
			{
				pAxisStatus->step = STEP_GLOBAL_INIT;
			}
			break;
		/* Global initialization */
		case STEP_GLOBAL_INIT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Global initialization");
			
			pAxisCtrl->config.velPos = pAxisCtrl->para.velPos;
			pAxisCtrl->config.velNeg = pAxisCtrl->para.velNeg;
			pAxisCtrl->config.jogVelPos = pAxisCtrl->para.jogVelPos;
			pAxisCtrl->config.jogVelNeg = pAxisCtrl->para.jogVelNeg;
			pAxisCtrl->config.absVel = pAxisCtrl->para.velPos;
			pAxisCtrl->config.relVel = pAxisCtrl->para.velPos;
			pAxisCtrl->config.basisOvrd_v = 10000;
			pAxisCtrl->config.basisOvrd_a = 10000;
			
			pAxisData->move.basis.parameter.v_pos = pAxisCtrl->para.velPos;
			pAxisData->move.basis.parameter.v_neg = pAxisCtrl->para.velNeg;
			pAxisData->move.basis.parameter.a1_pos = pAxisCtrl->para.accPos;
			pAxisData->move.basis.parameter.a1_neg = pAxisCtrl->para.decPos;
			pAxisData->move.basis.parameter.a2_pos = pAxisCtrl->para.accNeg;
			pAxisData->move.basis.parameter.a2_neg = pAxisCtrl->para.decNeg;
			pAxisData->move.basis.override.v = pAxisCtrl->config.basisOvrd_v;
			pAxisData->move.basis.override.a = pAxisCtrl->config.basisOvrd_a;
			
			pAxisData->encoder_if.parameter.count_dir = pAxisCtrl->para.countDir ? ncINVERSE : ncSTANDARD;
			
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncGLOBAL, ncINIT); 
			if ( ncOK == pAxisStatus->status )
			{
				pAxisStatus->step = STEP_WAIT_GLOBAL_INIT;
			}
			break;
		/* Wait for end of global initialization */
		case STEP_WAIT_GLOBAL_INIT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for end of global initialization");
			
			if ( ncTRUE == pAxisData->global.init )
			{
				pAxisStatus->step = STEP_SIMULATE_MODE;
			}
			break;
		/* Switch on/off simulation mode */
		case STEP_SIMULATE_MODE:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for end of Basic move initialization");
			
			if ( ncON == pAxisStatus->simulation )
			{
				pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncSIMULATION, ncSWITCH_ON);
			}
			else
			{
				pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncSIMULATION, ncSWITCH_OFF);
			}
			
			if ( ncOK == pAxisStatus->status )
			{
				pAxisStatus->step = STEP_WAIT_SIMULATE_STATUS;
			}
			break;
		/* Wait for simulation status ok */
		case STEP_WAIT_SIMULATE_STATUS:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for simulation status ok");
			
			if ( pAxisData->simulation.status == pAxisStatus->simulation )
			{
				pAxisStatus->step = STEP_INIT_CTRL_RDY;
			}
			break;
		/* INIT for wait until "Controller ready" */
		case STEP_INIT_CTRL_RDY:
			strcpy(&pAxisCtrl->monitor.strEng[0], "INIT for wait until Controller ready");
			
			pAxisStatus->waitCycles = 0;
			pAxisStatus->waitCyclesMax = 500;
			pAxisStatus->step = STEP_WAIT_CTRL_RDY;
			break;
		/* Wait until "Controller ready" */
		case STEP_WAIT_CTRL_RDY:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait until Controller ready");
			
			if ( ncTRUE == pAxisData->controller.ready )
			{
				pAxisStatus->step = STEP_SWITCH_ON;
			}
			pAxisStatus->waitCycles++; 
			if ( pAxisStatus->waitCycles >= pAxisStatus->waitCyclesMax )
			{
				/* After the maximum waiting period the ACOPOS is surely in an error state. */
				/* Entering of error records can be activated with "ncCONTROLLER,ncSWITCH_ON". */
				pAxisStatus->step = STEP_SWITCH_ON;
			}
			break;
		/* Switch controller on */
		case STEP_SWITCH_ON:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Switch controller on");
			
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncCONTROLLER, ncSWITCH_ON);
			if ( ncOK == pAxisStatus->status )
			{
				pAxisStatus->step = STEP_WAIT_SWITCH_ON;
			}
			break;
		/* Wait for controller on */
		case STEP_WAIT_SWITCH_ON:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for controller on");
			
			if ( ncON == pAxisData->controller.status )
			{
				pAxisStatus->step = STEP_HOME_START;
			}
			break;
		/* Start homing procedure */
		case STEP_HOME_START:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Start homing procedure");
			pAxisData->move.homing.parameter.s = pAxisCtrl->config.homeRefPosi;
			pAxisData->move.homing.parameter.mode = ncDIRECT;
		    
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncHOMING, ncSTART);
			if ( ncOK == pAxisStatus->status )
			{
				pAxisStatus->step = STEP_WAIT_HOME_OK;
			}
			break;
		/* Wait for end of homing procedure */
		case STEP_WAIT_HOME_OK:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for end of homing procedure");
			
			if ( ncTRUE == pAxisData->move.homing.status.ok )
			{
				pAxisStatus->step = STEP_COMMAND;
			}
			break;
		/* Select movement type */
		case STEP_COMMAND:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for COMMAND");
			
			if (pAxisCtrl->cmd.ctrlOff)
			{
				pAxisStatus->step = STEP_SWITCH_OFF_1;
				pAxisCtrl->cmd.ctrlOff = 0;
			}
			else if (pAxisCtrl->cmd.ctrlOn)
			{
				pAxisStatus->step = STEP_SWITCH_ON;
				pAxisCtrl->cmd.ctrlOn = 0;
			}
			else if (pAxisCtrl->cmd.moveE_Stop)
			{
				pAxisStatus->step = STEP_ESTOP_MOVEMENT;
			}
			else if (pAxisCtrl->cmd.moveStop)
			{
				pAxisStatus->step = STEP_STOP_MOVEMENT;
			}
			else if (pAxisCtrl->cmd.posMove)
			{
				pAxisStatus->step = STEP_POS_MOVEMENT;
				pAxisCtrl->cmd.posMove =0;
			}
			else if (pAxisCtrl->cmd.negMove)
			{
				pAxisStatus->step = STEP_NEG_MOVEMENT;
				pAxisCtrl->cmd.negMove = 0;
			}
			else if (pAxisCtrl->cmd.posJog)
			{
				pAxisStatus->step = STEP_POS_JOG;
			}
			else if (pAxisCtrl->cmd.negJog)
			{
				pAxisStatus->step = STEP_NEG_JOG;
			}
			else if (pAxisCtrl->cmd.absMove) 
			{
				pAxisStatus->step = STEP_ABS_MOVEMENT;
				pAxisCtrl->cmd.absMove = 0;
			}
			else if (pAxisCtrl->cmd.relMove)
			{
				pAxisStatus->step = STEP_REL_MOVEMENT;
				pAxisCtrl->cmd.relMove = 0;
			}
			else if (pAxisCtrl->cmd.stopCAM)
			{
				pAxisStatus->step = STEP_STOP_AUTOMAT;
				pAxisCtrl->cmd.stopCAM = 0;
			}
			else if (pAxisCtrl->cmd.startCAM)
			{
				pAxisStatus->step = STEP_START_AUTOMAT;
				pAxisCtrl->cmd.startCAM = 0;
			}
			else if (pAxisCtrl->cmd.restartCAM)
			{
				pAxisStatus->step = STEP_RESTART_AUTOMAT;
				pAxisCtrl->cmd.restartCAM = 0;
			}
			/*else if (pAxisCtrl->cmd.homing)
			{
				pAxisStatus->step = STEP_HOME_START;	
			}*/
			else if ( (0 == pAxisData->message.count.error) && (pAxisData->message.count.warning != 0) )
			{
				/* Acknowlege warning message */
				pAxisStatus->step = STEP_WMSSAGE_ACKN;
			}
			break;
		/* Start AutoMat */
		case STEP_START_AUTOMAT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Start AutoMat");
			
			pAxisStatus->serviceBuff.ui2 = ncSTART;
			pAxisData->network.service.data_adr = (UDINT)&pAxisStatus->serviceBuff.ui2;
			pAxisData->network.service.request.par_id = ACP10PAR_CMD_AUT_START;
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncSERVICE, ncSET);
			if ( ncOK == pAxisStatus->status )
			{
				pAxisStatus->step = STEP_WAIT_SERVICE_SET;
			}
			break;
		/* Restart Automat */
		case STEP_RESTART_AUTOMAT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Restart Automat");
			
			pAxisStatus->serviceBuff.ui2 = ncRESTART;
			pAxisData->network.service.data_adr = (UDINT)&pAxisStatus->serviceBuff.ui2;
			pAxisData->network.service.request.par_id = ACP10PAR_CMD_AUT_START;
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncSERVICE, ncSET);
			
			if ( ncOK == pAxisStatus->status )
			{
				pAxisStatus->step = STEP_WAIT_SERVICE_SET;
			}
			break;
		/* Stop Automat */
		case STEP_STOP_AUTOMAT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Stop Automat");
			
			pAxisStatus->serviceBuff.ui2 = ncSTOP;
			pAxisData->network.service.data_adr = (UDINT)&pAxisStatus->serviceBuff.ui2;
			pAxisData->network.service.request.par_id = ACP10PAR_CMD_AUT_START;
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncSERVICE, ncSET);
			if ( ncOK == pAxisStatus->status )
			{
				pAxisStatus->step = STEP_WAIT_SERVICE_SET;
			}
			break;	
		/* Wait service set completed */
		case STEP_WAIT_SERVICE_SET:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait service set completed");
			
			if ( pAxisData->network.service.response.par_id == pAxisData->network.service.request.par_id )
			{
				pAxisStatus->step = STEP_COMMAND;
			}
			break;
		/* Start movement in positive direction */
		case STEP_POS_MOVEMENT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Start movement in positive direction");
			
			pAxisData->move.basis.parameter.v_pos = pAxisCtrl->config.velPos;
			pAxisData->move.basis.parameter.a1_pos = pAxisCtrl->para.accPos;
			pAxisData->move.basis.parameter.a2_pos = pAxisCtrl->para.decPos;
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncPOS_MOVE, ncINIT + ncSTART);
			if ( ncOK == pAxisStatus->status )
			{	
				pAxisStatus->step = STEP_COMMAND;
			}	
			break;
		/* Start movement in negative direction */
		case STEP_NEG_MOVEMENT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Start movement in negative direction");
			
			pAxisData->move.basis.parameter.v_neg = pAxisCtrl->config.velNeg;
			pAxisData->move.basis.parameter.a1_neg = pAxisCtrl->para.accNeg;
			pAxisData->move.basis.parameter.a2_neg = pAxisCtrl->para.decNeg;
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncNEG_MOVE, ncINIT + ncSTART);
			if ( ncOK == pAxisStatus->status )
			{	
				pAxisStatus->step = STEP_COMMAND;
			}	
			break;
		/* Start jog in positive direction */
		case STEP_POS_JOG:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Start jog in positive direction");
			
			pAxisData->move.basis.parameter.v_pos = pAxisCtrl->config.jogVelPos;
			pAxisData->move.basis.parameter.a1_pos = pAxisCtrl->para.accPos;
			pAxisData->move.basis.parameter.a2_pos = pAxisCtrl->para.decPos;
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncPOS_MOVE, ncINIT + ncSTART);
			if ( ncOK == pAxisStatus->status )
			{	
				pAxisStatus->step = STEP_WAIT_POS_JOG;
			}	
			break;
		/* Wait for stopping jog in positive direction */
		case STEP_WAIT_POS_JOG:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for stopping jog in positive direction");
			
			if (!pAxisCtrl->cmd.posJog)
			{
				pAxisStatus->step = STEP_STOP_MOVEMENT;
			}
				if (pAxisCtrl->cmd.moveE_Stop)
			{
				pAxisStatus->step = STEP_ESTOP_MOVEMENT;
				pAxisCtrl->cmd.posJog = 0;
			}
			break;
		/* Start jog in negative direction */
		case STEP_NEG_JOG:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Start jog in negative direction");
			
			pAxisData->move.basis.parameter.v_neg = pAxisCtrl->config.jogVelNeg;
			pAxisData->move.basis.parameter.a1_neg = pAxisCtrl->para.accNeg;
			pAxisData->move.basis.parameter.a2_neg = pAxisCtrl->para.decNeg;
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncNEG_MOVE, ncINIT + ncSTART);
			if ( ncOK == pAxisStatus->status )
			{	
				pAxisStatus->step = STEP_WAIT_NEG_JOG;
			}	
			break;
		/* Wait for stopping jog in negative direction */
		case STEP_WAIT_NEG_JOG:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for stopping jog in negative direction");
			
			if (!pAxisCtrl->cmd.negJog)
			{
				pAxisStatus->step = STEP_STOP_MOVEMENT;
			}
				if (pAxisCtrl->cmd.moveE_Stop)
			{
				pAxisStatus->step = STEP_ESTOP_MOVEMENT;
				pAxisCtrl->cmd.negJog = 0;
			}
			break;
		/* Start abolute movement */
		case STEP_ABS_MOVEMENT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Start abolute movement");
			
			pAxisData->move.basis.parameter.s = pAxisCtrl->config.absPosi;
			pAxisData->move.basis.parameter.v_pos = pAxisCtrl->config.absVel;
			pAxisData->move.basis.parameter.v_neg = pAxisCtrl->config.absVel;
			pAxisData->move.basis.parameter.a1_pos = pAxisCtrl->para.accPos;
			pAxisData->move.basis.parameter.a2_pos = pAxisCtrl->para.decPos;
			pAxisData->move.basis.parameter.a1_neg = pAxisCtrl->para.accNeg;
			pAxisData->move.basis.parameter.a2_neg = pAxisCtrl->para.decNeg;
			
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncABS_MOVE, ncINIT + ncSTART);
			if ( ncOK == pAxisStatus->status )
			{	
				pAxisStatus->step = STEP_WAIT_IN_POS;
			}	
			break;
		/* Start relative movement */
		case STEP_REL_MOVEMENT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Start relative movement");
			
			pAxisData->move.basis.parameter.s = pAxisCtrl->config.relPosi;
			pAxisData->move.basis.parameter.v_pos = pAxisCtrl->config.relVel;
			pAxisData->move.basis.parameter.v_neg = pAxisCtrl->config.relVel;
			pAxisData->move.basis.parameter.a1_pos = pAxisCtrl->para.accPos;
			pAxisData->move.basis.parameter.a2_pos = pAxisCtrl->para.decPos;
			pAxisData->move.basis.parameter.a1_neg = pAxisCtrl->para.accNeg;
			pAxisData->move.basis.parameter.a2_neg = pAxisCtrl->para.decNeg;
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncREL_MOVE, ncINIT + ncSTART);
			if ( ncOK == pAxisStatus->status )
			{	
				pAxisStatus->step = STEP_WAIT_IN_POS;
			}	
			break;
		/* Wait for message "In Position" */
		case STEP_WAIT_IN_POS:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for message In Position");
			
			if (pAxisCtrl->cmd.moveE_Stop)
			{
				pAxisStatus->step = STEP_ESTOP_MOVEMENT;
			}
			else if (pAxisCtrl->cmd.moveStop)
			{
				pAxisStatus->step = STEP_STOP_MOVEMENT;
			}
			else if (ncTRUE == pAxisData->move.basis.status.in_pos)
			{
				pAxisStatus->step = STEP_COMMAND;	
			}
			break;
		/* Eergency Stop movement */
		case STEP_ESTOP_MOVEMENT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Eergency Stop movement");
			
			pAxisCtrl->cmd.moveE_Stop = 0;
			pAxisData->move.stop.index.command = 1;
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncMOVE, ncSTOP);
			if (ncOK == pAxisStatus->status)
			{					
				pAxisStatus->step = STEP_WAIT_STOP_MOVEMENT;
			}
			break;
		/* Stop movement */
		case STEP_STOP_MOVEMENT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Stop movement");
			
			pAxisCtrl->cmd.moveStop = 0;
			pAxisData->move.stop.index.command = 0;
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncMOVE, ncSTOP);
			
			if (ncOK == pAxisStatus->status)
			{					
				pAxisStatus->step = STEP_WAIT_STOP_MOVEMENT;
			}
			break;
		/* Wait for end of movement */
		case STEP_WAIT_STOP_MOVEMENT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for end of movement");
			
			if (ncOFF == pAxisData->move.mode)
			{
				pAxisStatus->step 	= STEP_COMMAND;
			}	
			break;
		/* Wait for end of movement */
		case STEP_SWITCH_OFF_1:	
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for end of movement");
			
			if (pAxisData->move.mode != ncOFF ) 
			{	
				pAxisData->move.stop.index.command = 1;				
				pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncMOVE, ncSTOP);
				if (ncOK == pAxisStatus->status)
				{
					pAxisStatus->step = STEP_SWITCH_OFF_2;
				}	
			}
			else
			{
				pAxisStatus->step = STEP_SWITCH_OFF_2;   
			}	
			break;	
		/* Switch controller off */
		case STEP_SWITCH_OFF_2:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Switch controller off");
			
			if (ncOFF == pAxisData->move.mode)
			{	
				pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncCONTROLLER, ncSWITCH_OFF);
				if (ncOK == pAxisStatus->status)
				{
					pAxisStatus->step = STEP_WAIT_SWITCH_OFF_2;
				}	
			}	
			break;
		/* Wait for controller off */
		case STEP_WAIT_SWITCH_OFF_2:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for controller off");
			
			if (ncOFF == pAxisData->controller.status)
			{		
				pAxisStatus->step = STEP_COMMAND;	
			}
			break;	
		/* Acknowlege warning messages */
		case STEP_WMSSAGE_ACKN:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Acknowlege warning messages");
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncMESSAGE, ncACKNOWLEDGE);
			if (ncOK == pAxisStatus->status)
			{	               			
				pAxisStatus->step = STEP_COMMAND;	        		
			}
			break;
		/* Beginning of error steps */
		case STEP_ERROR_STEP:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Beginning of error steps");
			/* Stop active movement if required */
			pAxisCtrl->cmd.negJog = 0;
			pAxisCtrl->cmd.posJog = 0;
			if ( (ncON == pAxisStatus->errorHalt) && (pAxisData->move.mode != ncOFF) )
			{	
				pAxisData->move.stop.index.command = 1;				
				pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncMOVE, ncSTOP);
				if (ncOK  == pAxisStatus->status)
				{
					pAxisStatus->step = STEP_ERR_SWITCH_OFF;
				}	
			}
			else
			{
				pAxisStatus->step = STEP_ERR_SWITCH_OFF;   
			}	
			break;
		/* Switch controller off if required */
		case STEP_ERR_SWITCH_OFF:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Switch controller off if required");
			
			if ( (ncON == pAxisStatus->ctrlOff) && 
				(ncON == pAxisData->controller.status) &&
				(ncOFF == pAxisData->move.mode) )
			{
				pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncCONTROLLER, ncSWITCH_OFF);
				if (ncOK == pAxisStatus->status)
				{
					pAxisStatus->step = STEP_WAIT_ERR_SWITCH_OFF;
				}
			}
			else if ( (pAxisStatus->ctrlOff != ncON) || (ncOFF == pAxisData->controller.status) )
			{
				pAxisStatus->step = STEP_WAIT_MESSAGE_NUMBER;   
			}
			break;
		/* Wait for controller off */
		case STEP_WAIT_ERR_SWITCH_OFF:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for controller off");
			
			if (ncOFF == pAxisData->controller.status)
			{	
				pAxisStatus->step = STEP_WAIT_MESSAGE_NUMBER;
			}
			break;
		/* Wait until the number is entered in the current message record */
		case STEP_WAIT_MESSAGE_NUMBER:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait until the number is entered in the current message record");
			
			if ( pAxisData->message.record.number != 0 )
			{
				/* "monitor.status.error/warning" are bits in the cyclic status information */
				/* the message record will be read from the drive */
				pAxisStatus->step = STEP_MESSAGE_TEXT;
			}
			break;
		/* Determine text for current message record */
		case STEP_MESSAGE_TEXT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Determine text for current message record");
			
			pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncMESSAGE, ncTEXT);
			if (ncOK == pAxisStatus->status)
			{
				pAxisStatus->step = STEP_WAIT_MESSAGE_TEXT;
			}
			break;
		/* Wait for end of text determination */
		case STEP_WAIT_MESSAGE_TEXT:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Wait for end of text determination");
			
			if ( (pAxisData->message.text.status.lines != 0) || 
				(pAxisData->message.text.status.error != 0) )
			{
				pAxisStatus->step = STEP_MESSAGE_ACKN;
			}
			break;
		/* Acknowledge current message record */
		case STEP_MESSAGE_ACKN:
			strcpy(&pAxisCtrl->monitor.strEng[0], "Acknowledge current message record");
			
			if ( pAxisCtrl->cmd.errAck )
			{
				pAxisStatus->status = ncaction(pAxisStatus->axisObj, ncMESSAGE, ncACKNOWLEDGE);
				if (ncOK == pAxisStatus->status)
				{	
					pAxisCtrl->cmd.errAck = 0;
					if (0 == pAxisData->message.record.number)
					{
						/* all message records acknowledged */
						pAxisCtrl->monitor.messageText.line_01[0] = 0;
						pAxisCtrl->monitor.messageText.line_02[0] = 0;
						pAxisCtrl->monitor.messageText.line_03[0] = 0;
						pAxisCtrl->monitor.messageText.line_04[0] = 0;
						pAxisStatus->step = STEP_WAIT_INIT_ALLOWED;
						pAxisCtrl->monitor.errStep = 0;
					}
					else
					{
						pAxisStatus->step = STEP_MESSAGE_TEXT;
					}
				}
			}
			break;
	}/* switch (pAxisStatus->step) */

}/* void _CYCLIC SingleAxCYCLIC(void) */

void _EXIT SingleAxEXIT(void)
{
	/* TODO: Add code here */
}/* void _EXIT SingleAxEXIT(void) */
